/*
 * $Log: skem.h,v $
 * Revision 1.1  2004/07/14 06:11:16  mi
 * Initial revision
 *
 */
/*
 * Modifications of the options are only allowed to the main program
 */
#ifdef SKEM_MAIN_PROGRAM
#	define SKEM_CONST
#else
#	define SKEM_CONST const
#endif

struct skem_options {
	const size_t	 	size;
	SKEM_CONST unsigned int	grace;
	SKEM_CONST int		tempfail;
	SKEM_CONST uid_t	uid;
	const char	* SKEM_CONST cwd;
	char		* SKEM_CONST socket;
	const char	* SKEM_CONST pidfname;
#ifdef SKEM_LOGWATCHER
	SKEM_CONST pthread_t	watch_thread;
	const char	* SKEM_CONST reject, * SKEM_CONST ippattern;
	const char	* SKEM_CONST spamword;
#endif
#ifdef SKEM_CLEANUP
	SKEM_CONST pthread_t	clean_thread;
	SKEM_CONST unsigned int	 permcleanup;
	SKEM_CONST struct timeval	 cleanupperiod;
#endif
};

extern SKEM_CONST struct skem_options O;

/* Declaration mandated by the pthread_create() */
#ifdef SKEM_CLEANUP
void	*skem_cleanup(void *);
extern const char *cleanup_version;
#endif
#ifdef SKEM_LOGWATCHER
extern int	inprogress;
extern int	mustexit;
void	*skem_logwatch(void *);
extern const char *logwatch_version;
#endif

int	 skem_isanIP(const char *string);
int	 skem_touch(const char *filename, int mode);

/*
 * For some reason, milters are not expected to volunterely exit.
 * Ever... So the functionality, that handles exits gracefully is
 * hidden in libmilter.h, which is not installed normally...
 * Here I declare the pieces I need:
 */
#ifndef _LIBMILTER_H
void	 mi_stop_milters(int);
#	define MILTER_CONT	0
#	define MILTER_STOP	1
#	define MILTER_ABRT	2
#endif

